/**   
* @Title: CustomerManager.java 
* @Package com.hdp.customerservice.websocket 
* @Description: TODO
* @author new12304508_163_com   
* @date 2015年6月16日 下午4:49:51 
* @version V1.0   
*/
package com.hdp.customerservice.websocket;

import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.LinkedBlockingQueue;

import org.springframework.util.StringUtils;

import com.hdp.customerservice.websocket.model.Customer;
import com.hdp.pi.wechat.messages.AbstractMessage;

public class CustomerManager {
	
	private static ConcurrentHashMap<String,Customer> 
				users = new ConcurrentHashMap<String, Customer>();
	
	private CustomerManager(){}
	
	public static Customer getUserByOpenId(String openId){
		if(StringUtils.isEmpty(openId)){
			return null;
		}
		return users.get(openId);
	}
	
	public static void addUser(Customer user){
		if(user == null || StringUtils.isEmpty(user.openId)){
			return;
		}
		users.put(user.openId, user);
	}
	
	public static void addUserIfNotExist(AbstractMessage e){
		String openId=e.openId;
		Customer user = users.get(openId);
		if(user == null){
			user = new Customer();
			user.openId= e.openId;
			users.put(openId, user);
		}
	}
	
	public static Customer[] getUsers(){
		Customer[] us = new Customer[users.size()];
		return users.values().toArray(us);
	}
}
