/**   
* @Title: IMManager.java 
* @Package com.hdp.customerservice 
* @Description: TODO
* @author new12304508_163_com   
* @date 2015年6月15日 下午2:59:46 
* @version V1.0   
*/
package com.hdp.customerservice.websocket;

import java.io.IOException;
import java.util.Date;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.LinkedBlockingQueue;

import javax.websocket.Session;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.alibaba.fastjson.JSONObject;
import com.hdp.customerservice.websocket.model.Waiter;
import com.hdp.pi.wechat.messages.AbstractMessage;
import com.hdp.pi.wechat.messages.NewUserMessage;

public final class IMManager {
	private static Log log=LogFactory.getLog(IMManager.class);
	
	private static ExecutorService pool = Executors.newFixedThreadPool(Runtime.getRuntime().availableProcessors() * 2);
			
	private static CopyOnWriteArrayList<Waiter> waiters = new CopyOnWriteArrayList<Waiter>();
	
	private static LinkedBlockingQueue<AbstractMessage> queue=new LinkedBlockingQueue<AbstractMessage>();
	
	private IMManager(){}
	public static void pushMessage(AbstractMessage message){
		try{
			addUserIfNotExist(message);
		}catch(Throwable e){
			
		}
		try {
			queue.put(message);
		} catch (InterruptedException e) {
		}
	}
	
	public static void addUserIfNotExist(AbstractMessage e){
		NewUserMessage newUserMessage=new NewUserMessage();
		newUserMessage.appId=e.appId;
		newUserMessage.createTime=new Date();
		newUserMessage.entCode=e.entCode;
		newUserMessage.openId=e.openId;
		try {
			queue.put(e);
		} catch (InterruptedException e1) {
		}
	}
	
	public static void broadcast(AbstractMessage message){
		String m = JSONObject.toJSONString(message);
		for (Waiter waiter : waiters) {
			/*if(waiter == null || 
					message.entCode == null || 
					waiter.entCode == null ||
					waiter.entCode.intValue() != message.entCode.intValue()){//没有客服
				continue;
			}*/
			Session session= waiter.session;
			/*if(session == null || !session.isOpen()){
				return;
			}*/
			try {
				session.getBasicRemote().sendText(m);
			} catch (IOException e1) {
			}
		}
	}
	public static void addWaiter(Waiter w){
		waiters.add(w);
	}
	
	public static void removeWaiter(Waiter w){
		waiters.remove(w);
	}
	static{
		int pross = Runtime.getRuntime().availableProcessors();
		if(pross == 0 ){
			pross = 1;
		}
		for(int i=0;i<pross;i++){
			pool.execute(new Runnable() {//消息发射器
				public void hand(){
					AbstractMessage e=queue.poll();
					if(e == null){
						try {
							Thread.sleep(50);
						} catch (InterruptedException e1) {
						}
						return ;
					}
					broadcast(e);
				}
				
				@Override
				public void run() {
					while(true){
						try{
							hand();
						}catch(Throwable e){}
					}
				}
			});
		}
	}
}
