package com.hdp.customerservice.websocket;

import java.io.IOException;

import javax.servlet.http.HttpSession;
import javax.websocket.EndpointConfig;
import javax.websocket.OnClose;
import javax.websocket.OnError;
import javax.websocket.OnMessage;
import javax.websocket.OnOpen;
import javax.websocket.Session;
import javax.websocket.server.ServerEndpoint;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.socket.CloseStatus;
import org.springframework.web.socket.WebSocketHandler;
import org.springframework.web.socket.WebSocketMessage;
import org.springframework.web.socket.WebSocketSession;
import org.springframework.web.socket.handler.WebSocketHandlerDecorator;

import com.hdp.customerservice.model.WorksEntity;
import com.hdp.customerservice.websocket.model.Waiter;

@ServerEndpoint(value="/im"/*,configurator=GetHttpSessionConfigurator.class*/)
public class IMWebSocketEndpoint{
	private static Log log=LogFactory.getLog(IMWebSocketEndpoint.class);
	private Waiter waiter;
	@OnOpen
	public void handleConnect(Session session/*,EndpointConfig config*/) throws IOException{
        this.waiter = new Waiter();
        String str=session.getQueryString();
        str = str.substring(str.indexOf("ent_code=")+9);
        this.waiter.entCode = Integer.parseInt(str);
        this.waiter.session = session;
		IMManager.addWaiter(waiter);
	}
	
	@OnClose
	public void handleClose(Session session){
		IMManager.removeWaiter(waiter);
	}
	
	@OnError
	public void handleError(Throwable t){
		log.info(t);
	}
	
	@OnMessage
	public void handleMessage(Session session, String message) throws IOException {
		session.getBasicRemote().sendText(message);
	}
}
